﻿''' <summary>
''' 値本体
''' </summary>
Public MustInherit Class ValueBody
    Inherits ByBlock

    ''' <summary>
    ''' キーセット
    ''' </summary>
    ''' <remarks></remarks>
    Public Class Pair
        Public key As ValueBlock
        Public value As ValueBlock
    End Class

    ''' <summary>
    ''' 構築
    ''' <param name="value">値</param>
    ''' </summary>
    Protected Sub New(ByVal value As Object)
        Me._value = value
    End Sub

    ''' <summary>
    ''' 値
    ''' </summary>
    Private _value As Object
    Protected Property Value As Object
        Get
            Return Me._value
        End Get
        Set(ByVal value As Object)
            Me._value = value
        End Set
    End Property

    ''' <summary>
    ''' キーセット配列作成
    ''' </summary>
    ''' <param name="dic">ディクショナリ</param>
    ''' <returns>キーセット配列</returns>
    Protected Shared Function ToPairs(ByVal dic As Object) As List(Of Pair)
        Dim pairs As New List(Of Pair)
        If Not IsNothing(dic) Then
            Dim type As Type = dic.GetType()
            Dim propkeys As System.Reflection.PropertyInfo = type.GetProperty("Keys")
            Dim keys As New List(Of ValueBlock)
            For Each o As Object In propkeys.GetValue(dic, Nothing)
                keys.Add(New ValueBlock(o))
            Next
            Dim propvalues As System.Reflection.PropertyInfo = type.GetProperty("Values")
            Dim values As New List(Of ValueBlock)
            For Each o As Object In propvalues.GetValue(dic, Nothing)
                values.Add(New ValueBlock(o))
            Next
            For i As Integer = 0 To keys.Count - 1
                Dim p As New Pair()
                p.key = keys.Item(i)
                p.value = values.Item(i)
                pairs.Add(p)
            Next
        End If
        Return pairs
    End Function

    ''' <summary>
    ''' 値ブロック配列作成
    ''' </summary>
    ''' <param name="array">配列</param>
    ''' <returns>値ブロック配列</returns>
    Protected Shared Function ToBlocks(ByVal array() As Object) As List(Of ValueBlock)
        Dim ls As New List(Of ValueBlock)
        If Not IsNothing(array) Then
            For Each o As Object In array
                ls.Add(New ValueBlock(o))
            Next
        End If
        Return ls
    End Function

End Class
