﻿''' <summary>
''' ArrayList値
''' </summary>
Public Class ArrayListValueBody
    Inherits ValueBody

    ''' <summary>
    ''' 構築
    ''' <param name="o">オブジェクト</param>
    ''' </summary>
    Public Sub New(ByVal o As ArrayList)
        MyBase.New(ToBlocks(If(Not IsNothing(o), o.ToArray(), Nothing)))
    End Sub

    ''' <summary>
    ''' 配列取得
    ''' </summary>
    ''' <returns>配列</returns>
    Public Function GetValue() As List(Of ValueBlock)
        Return Me.Value
    End Function

    ''' <summary>
    ''' 書込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Write(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        WriteInteger(stream, GetValue().Count)
        For Each block As ValueBlock In GetValue()
            block.Write(stream, map)
        Next
    End Sub

    ''' <summary>
    ''' 読込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Read(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        GetValue().Clear()
        Dim leng As Integer = ReadInteger(stream)
        For i As Integer = 0 To leng - 1
            Dim block As ValueBlock = New ValueBlock()
            block.Read(stream, map)
            GetValue().Add(block)
        Next
    End Sub

    ''' <summary>
    ''' 参照オブジェクト収集
    ''' </summary>
    ''' <param name="map">参照オブジェクトMAP</param>
    ''' <returns>参照オブジェクトMAP</returns>
    Public Overrides Function CollectReferenceObject(ByVal map As HashSet(Of Object))
        For Each block As ValueBlock In GetValue()
            map = block.CollectReferenceObject(map)
        Next
        Return map
    End Function

    ''' <summary>
    ''' 値を格納する
    ''' </summary>
    ''' <returns>インスタンス</returns>
    Public Overrides Function ResolveValue() As Object
        Dim ls As ArrayList = New ArrayList()
        For Each bl As ValueBlock In GetValue()
            ls.Add(bl.ResolveValue())
        Next
        Return ls
    End Function

End Class
