﻿''' <summary>
''' カラー値
''' </summary>
Public Class ColorValueBody
    Inherits ValueBody

    ''' <summary>
    ''' 構築
    ''' <param name="value">値</param>
    ''' </summary>
    Public Sub New(ByVal value As System.Drawing.Color)
        MyBase.New(value)
    End Sub

    ''' <summary>
    ''' 値取得
    ''' </summary>
    ''' <returns>値</returns>
    Public Function GetValue() As System.Drawing.Color
        Return Me.Value
    End Function

    ''' <summary>
    ''' 書込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Write(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        WriteInteger(stream, GetValue().ToArgb())
    End Sub

    ''' <summary>
    ''' 読込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Read(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        Dim rgb As Integer = ReadInteger(stream)
        Me.Value = System.Drawing.Color.FromArgb(rgb)
    End Sub

    ''' <summary>
    ''' 値を格納する
    ''' </summary>
    ''' <returns>インスタンス</returns>
    Public Overrides Function ResolveValue() As Object
        Return GetValue()
    End Function

End Class
