﻿''' <summary>
''' 日付値
''' </summary>
''' <remarks></remarks>
Public Class DateValueBody
    Inherits ValueBody

    ''' <summary>
    ''' 構築
    ''' <param name="value">値</param>
    ''' </summary>
    Public Sub New(ByVal value As Date)
        MyBase.New(value)
    End Sub

    ''' <summary>
    ''' 値取得
    ''' </summary>
    ''' <returns>値</returns>
    Public Function GetValue() As Date
        Return Me.Value
    End Function

    ''' <summary>
    ''' 書込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Write(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        Dim v As Long = If(Not IsNothing(Me.Value), GetValue().Ticks, 0L)
        WriteLong(stream, v)
    End Sub

    ''' <summary>
    ''' 読込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Read(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        Me.Value = New Date(ReadLong(stream))
    End Sub

    ''' <summary>
    ''' 値を格納する
    ''' </summary>
    ''' <returns>インスタンス</returns>
    Public Overrides Function ResolveValue() As Object
        Return GetValue()
    End Function

End Class
