﻿Public Class ExternalValueBody
    Inherits ValueBody

    ''' <summary>
    ''' 構築
    ''' <param name="o">オブジェクト</param>
    ''' </summary>
    Public Sub New(ByVal o As Object)
        MyBase.New(o)
    End Sub

    ''' <summary>
    ''' 書込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Write(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        If Not IsNothing(Me.Value) AndAlso Not IsNothing(Me.Value.GetType()) Then
            WriteString(stream, Me.Value.GetType().FullName)
            If Not IsNothing(map.GetExternalBlockListener()) Then
                map.GetExternalBlockListener().Write(stream, map, Me.Value)
            End If
        Else
            WriteString(stream, "")
        End If
    End Sub

    ''' <summary>
    ''' 読込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Read(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        Dim name As String = ReadString(stream)
        If Not IsNothing(name) AndAlso name.Length > 0 Then
            Me.Value = map.GetExternalBlockListener().Read(stream, map, name)
        End If
    End Sub

    ''' <summary>
    ''' 参照オブジェクト収集
    ''' </summary>
    ''' <param name="map">参照オブジェクトMAP</param>
    ''' <returns>参照オブジェクトMAP</returns>
    Public Overrides Function CollectReferenceObject(ByVal map As HashSet(Of Object))
        Return map
    End Function

    ''' <summary>
    ''' 値を格納する
    ''' </summary>
    ''' <returns>インスタンス</returns>
    Public Overrides Function ResolveValue() As Object
        Return Me.Value
    End Function

End Class
