﻿''' <summary>
''' 座標値
''' </summary>
Public Class PointValueBody
    Inherits ValueBody

    ''' <summary>
    ''' 構築
    ''' <param name="value">値</param>
    ''' </summary>
    Public Sub New(ByVal value As System.Drawing.Point)
        MyBase.New(value)
    End Sub

    ''' <summary>
    ''' 値取得
    ''' </summary>
    ''' <returns>値</returns>
    Public Function GetValue() As System.Drawing.Point
        Return Me.Value
    End Function

    ''' <summary>
    ''' 書込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Write(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        WriteInteger(stream, GetValue().X)
        WriteInteger(stream, GetValue().Y)
    End Sub

    ''' <summary>
    ''' 読込
    ''' </summary>
    ''' <param name="stream">ストリーム</param>
    ''' <param name="map">Bysonマップ</param>
    Public Overrides Sub Read(ByVal stream As System.IO.Stream, ByVal map As BysonMap)
        Dim x As Integer = ReadInteger(stream)
        Dim y As Integer = ReadInteger(stream)
        Me.Value = New System.Drawing.Point(x, y)
    End Sub

    ''' <summary>
    ''' 値を格納する
    ''' </summary>
    ''' <returns>インスタンス</returns>
    Public Overrides Function ResolveValue() As Object
        Return GetValue()
    End Function

End Class
