﻿Public Class BysonForm

    Private WithEvents clientPanel As System.Windows.Forms.PictureBox
    Private Const FILE_FILTER As String = "my file(*.dat)|*.dat|all(*.*)|*.*"

    Private _filename As String = "nontitle"
    Private _document As New Document
    Private _storage As New MyStorage()

    Private Sub BysonForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.clientPanel = Me.PictureBoxCanvas
        Me.PictureBoxCanvas.Cursor = Cursors.Hand
        For Each s As FontSize In {New FontSize("Small", 8), New FontSize("Normal", 14), New FontSize("Large", 20)}
            Me.ComboBoxFont.Items.Add(s)
        Next
        Me.ComboBoxFont.SelectedIndex = 0
        For Each c As FontColor In {New FontColor("Red", Color.Red), New FontColor("Green", Color.Green), New FontColor("Blue", Color.Blue)}
            Me.ComboBoxColor.Items.Add(c)
        Next
        Me.ComboBoxColor.SelectedIndex = 0
    End Sub

    Private Sub Canvas_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles clientPanel.Paint
        For Each text As Text In Me._document.List
            text.draw(e.Graphics)
        Next
    End Sub

    Private Sub Canvas_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles clientPanel.MouseClick
        If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
            Dim dlg As New DlgText()
            If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
                Dim tx As Text = New Text(CType(Me.ComboBoxFont.SelectedItem, FontSize), CType(Me.ComboBoxColor.SelectedItem, FontColor))
                tx.X = e.X
                tx.Y = e.Y
                tx.Text = dlg.Value
                Me._document.List.Add(tx)
            End If
        End If
        Me.PictureBoxCanvas.Invalidate()
    End Sub

    Private Sub ButtonExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonExit.Click
        Me.Close()
    End Sub

    Private Sub ButtonOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOpen.Click
        Dim dlg As New OpenFileDialog()
        dlg.Filter = FILE_FILTER
        dlg.FilterIndex = 1
        dlg.Title = "open me"
        If dlg.ShowDialog() = DialogResult.OK Then
            Me._filename = dlg.FileName
            If Me._storage.IsMyFile(Me._filename) Then
                Me._document = Me._storage.Read(Me._filename)
                Me.PictureBoxCanvas.Invalidate()
            Else
                MessageBox.Show("It is not my file !", "byson", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End If
        End If
    End Sub

    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click
        Dim dlg As New SaveFileDialog()
        dlg.FileName = System.IO.Path.GetFileName(Me._filename)
        dlg.Filter = FILE_FILTER
        dlg.FilterIndex = 1
        dlg.Title = "save me"
        If dlg.ShowDialog() = DialogResult.OK Then
            Me._filename = dlg.FileName
            Me._storage.Write(Me._filename, Me._document)
        End If
    End Sub

End Class
